> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Create an API connector

POST https://api.sigmacomputing.com/v2/api-connectors
Content-Type: application/json

This endpoint creates a new API connector that defines how to call an external HTTP endpoint from within Sigma. For more information on API connectors, see [Configure API credentials and connectors in Sigma](https://help.sigmacomputing.com/docs/configure-api-credentials-and-connectors-in-sigma).

### Usage notes
- The user making this request must be assigned an account type with the **Manage API connectors** permission enabled.
- If a credential is provided using the `authId` parameter, the user making this request must have at least **Can view** permission on the credential and the request URL must match the credential's allowlist.
- Retrieve the **apiCredentialId** (used as `authId`) by calling the [/v2/api-credentials](https://help.sigmacomputing.com/reference/list-api-credentials) endpoint.

### Usage scenarios
- **Programmatic connector setup:** Automate creation of API connectors as part of an environment provisioning workflow.
- **Integration onboarding:** Create connectors for each external service your workbooks need to interact with.

Reference: https://help.sigmacomputing.com/reference/create-api-connector

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/api-connectors:
    post:
      operationId: createApiConnector
      summary: Create an API connector
      description: >-
        This endpoint creates a new API connector that defines how to call an
        external HTTP endpoint from within Sigma. For more information on API
        connectors, see [Configure API credentials and connectors in
        Sigma](https://help.sigmacomputing.com/docs/configure-api-credentials-and-connectors-in-sigma).


        ### Usage notes

        - The user making this request must be assigned an account type with the
        **Manage API connectors** permission enabled.

        - If a credential is provided using the `authId` parameter, the user
        making this request must have at least **Can view** permission on the
        credential and the request URL must match the credential's allowlist.

        - Retrieve the **apiCredentialId** (used as `authId`) by calling the
        [/v2/api-credentials](https://help.sigmacomputing.com/reference/list-api-credentials)
        endpoint.


        ### Usage scenarios

        - **Programmatic connector setup:** Automate creation of API connectors
        as part of an environment provisioning workflow.

        - **Integration onboarding:** Create connectors for each external
        service your workbooks need to interact with.
      tags:
        - apiConnectors
      parameters:
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/api-connectors_createApiConnector_Response_200
      requestBody:
        description: The request body.
        content:
          application/json:
            schema:
              type: object
              properties:
                name:
                  type: string
                  description: Display name of the connector.
                params:
                  $ref: >-
                    #/components/schemas/V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParams
                description:
                  type: string
                  description: Human-readable description.
                config:
                  $ref: >-
                    #/components/schemas/V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaConfig
                authId:
                  type: string
                  description: >-
                    Identifier of the API credential (`apiCredentialId`) used to
                    authenticate requests.
              required:
                - name
                - params
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsMethod:
      type: string
      enum:
        - GET
        - POST
        - DELETE
        - PATCH
        - PUT
        - OPTIONS
        - HEAD
      description: HTTP method to invoke.
      title: V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsMethod
    V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsHeadersItemsMode:
      type: string
      enum:
        - static
        - dynamic
      title: >-
        V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsHeadersItemsMode
    V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsHeadersItemsType:
      type: string
      enum:
        - array
        - boolean
        - number
        - object
        - raw
        - string
      title: >-
        V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsHeadersItemsType
    ParamShapeNodeOneOf0TypeItems:
      type: string
      enum:
        - string
      title: ParamShapeNodeOneOf0TypeItems
    ParamShapeNode0:
      type: object
      properties:
        type:
          type: array
          items:
            $ref: '#/components/schemas/ParamShapeNodeOneOf0TypeItems'
      required:
        - type
      title: ParamShapeNode0
    ParamShapeNodeOneOf1TypeItems:
      type: string
      enum:
        - number
      title: ParamShapeNodeOneOf1TypeItems
    ParamShapeNode1:
      type: object
      properties:
        type:
          type: array
          items:
            $ref: '#/components/schemas/ParamShapeNodeOneOf1TypeItems'
      required:
        - type
      title: ParamShapeNode1
    ParamShapeNodeOneOf2TypeItems:
      type: string
      enum:
        - boolean
      title: ParamShapeNodeOneOf2TypeItems
    ParamShapeNode2:
      type: object
      properties:
        type:
          type: array
          items:
            $ref: '#/components/schemas/ParamShapeNodeOneOf2TypeItems'
      required:
        - type
      title: ParamShapeNode2
    ParamShapeNodeOneOf3TypeItems:
      type: string
      enum:
        - object
      title: ParamShapeNodeOneOf3TypeItems
    ParamShapeNode3:
      type: object
      properties:
        type:
          type: array
          items:
            $ref: '#/components/schemas/ParamShapeNodeOneOf3TypeItems'
        properties:
          type: object
          additionalProperties:
            $ref: '#/components/schemas/ParamShapeNode'
      required:
        - type
        - properties
      title: ParamShapeNode3
    ParamShapeNodeOneOf4TypeItems:
      type: string
      enum:
        - array
      title: ParamShapeNodeOneOf4TypeItems
    ParamShapeNode4:
      type: object
      properties:
        type:
          type: array
          items:
            $ref: '#/components/schemas/ParamShapeNodeOneOf4TypeItems'
        items:
          $ref: '#/components/schemas/ParamShapeNode'
      required:
        - type
        - items
      title: ParamShapeNode4
    ParamShapeNode:
      oneOf:
        - $ref: '#/components/schemas/ParamShapeNode0'
        - $ref: '#/components/schemas/ParamShapeNode1'
        - $ref: '#/components/schemas/ParamShapeNode2'
        - $ref: '#/components/schemas/ParamShapeNode3'
        - $ref: '#/components/schemas/ParamShapeNode4'
        - type: object
          additionalProperties:
            description: Any type
      title: ParamShapeNode
    V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsHeadersItems:
      type: object
      properties:
        key:
          type: string
        mode:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsHeadersItemsMode
        value:
          type:
            - string
            - 'null'
        type:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsHeadersItemsType
        shape:
          oneOf:
            - $ref: '#/components/schemas/ParamShapeNode'
            - type: 'null'
      required:
        - key
        - mode
      title: >-
        V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsHeadersItems
    V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsPathParamsItemsMode:
      type: string
      enum:
        - static
        - dynamic
      title: >-
        V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsPathParamsItemsMode
    V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsPathParamsItemsType:
      type: string
      enum:
        - array
        - boolean
        - number
        - object
        - raw
        - string
      title: >-
        V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsPathParamsItemsType
    V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsPathParamsItems:
      type: object
      properties:
        key:
          type: string
        mode:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsPathParamsItemsMode
        value:
          type:
            - string
            - 'null'
        type:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsPathParamsItemsType
        shape:
          oneOf:
            - $ref: '#/components/schemas/ParamShapeNode'
            - type: 'null'
      required:
        - key
        - mode
      title: >-
        V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsPathParamsItems
    V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsQueryParamsItemsMode:
      type: string
      enum:
        - static
        - dynamic
      title: >-
        V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsQueryParamsItemsMode
    V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsQueryParamsItemsType:
      type: string
      enum:
        - array
        - boolean
        - number
        - object
        - raw
        - string
      title: >-
        V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsQueryParamsItemsType
    V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsQueryParamsItems:
      type: object
      properties:
        key:
          type: string
        mode:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsQueryParamsItemsMode
        value:
          type:
            - string
            - 'null'
        type:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsQueryParamsItemsType
        shape:
          oneOf:
            - $ref: '#/components/schemas/ParamShapeNode'
            - type: 'null'
      required:
        - key
        - mode
      title: >-
        V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsQueryParamsItems
    V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParams:
      type: object
      properties:
        method:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsMethod
          description: HTTP method to invoke.
        url:
          type: string
          description: >-
            Request URL. Must resolve to a hostname matching the associated
            credential's allowlist.
        headers:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsHeadersItems
          description: Static or dynamic request headers.
        pathParams:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsPathParamsItems
          description: Path parameter placeholders resolved into the URL.
        queryParams:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParamsQueryParamsItems
          description: Query string parameters.
        body:
          type: string
          description: Raw request body template.
      required:
        - method
        - url
        - headers
        - pathParams
        - queryParams
        - body
      title: V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaParams
    V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaConfigTimeout:
      type: object
      properties:
        requestSec:
          type: number
          format: double
      required:
        - requestSec
      description: Per-request timeout configuration.
      title: V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaConfigTimeout
    V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaConfigRetry:
      type: object
      properties:
        maxRetries:
          type: number
          format: double
        retryableStatusCodes:
          type: array
          items:
            type: number
            format: double
      required:
        - maxRetries
        - retryableStatusCodes
      description: >-
        Retry policy. `retryableStatusCodes` are HTTP codes that should trigger
        a retry.
      title: V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaConfigRetry
    V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaConfigRedirects:
      type: object
      properties:
        maxRedirects:
          type: number
          format: double
      required:
        - maxRedirects
      description: HTTP redirect handling.
      title: >-
        V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaConfigRedirects
    V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaConfigRateLimit:
      type: object
      properties:
        maxRequestsPerWindow:
          type: number
          format: double
      required:
        - maxRequestsPerWindow
      description: Rate limit applied to outbound requests from this connector.
      title: >-
        V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaConfigRateLimit
    V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaConfig:
      type: object
      properties:
        timeout:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaConfigTimeout
          description: Per-request timeout configuration.
        retry:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaConfigRetry
          description: >-
            Retry policy. `retryableStatusCodes` are HTTP codes that should
            trigger a retry.
        redirects:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaConfigRedirects
          description: HTTP redirect handling.
        rateLimit:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaConfigRateLimit
          description: Rate limit applied to outbound requests from this connector.
      title: V2ApiConnectorsPostRequestBodyContentApplicationJsonSchemaConfig
    V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsMethod:
      type: string
      enum:
        - GET
        - POST
        - DELETE
        - PATCH
        - PUT
        - OPTIONS
        - HEAD
      description: HTTP method to invoke.
      title: V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsMethod
    V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsHeadersItemsMode:
      type: string
      enum:
        - static
        - dynamic
      title: >-
        V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsHeadersItemsMode
    V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsHeadersItemsType:
      type: string
      enum:
        - array
        - boolean
        - number
        - object
        - raw
        - string
      title: >-
        V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsHeadersItemsType
    V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsHeadersItems:
      type: object
      properties:
        key:
          type: string
        mode:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsHeadersItemsMode
        value:
          type:
            - string
            - 'null'
        type:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsHeadersItemsType
        shape:
          oneOf:
            - $ref: '#/components/schemas/ParamShapeNode'
            - type: 'null'
      required:
        - key
        - mode
      title: >-
        V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsHeadersItems
    V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsPathParamsItemsMode:
      type: string
      enum:
        - static
        - dynamic
      title: >-
        V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsPathParamsItemsMode
    V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsPathParamsItemsType:
      type: string
      enum:
        - array
        - boolean
        - number
        - object
        - raw
        - string
      title: >-
        V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsPathParamsItemsType
    V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsPathParamsItems:
      type: object
      properties:
        key:
          type: string
        mode:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsPathParamsItemsMode
        value:
          type:
            - string
            - 'null'
        type:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsPathParamsItemsType
        shape:
          oneOf:
            - $ref: '#/components/schemas/ParamShapeNode'
            - type: 'null'
      required:
        - key
        - mode
      title: >-
        V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsPathParamsItems
    V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsQueryParamsItemsMode:
      type: string
      enum:
        - static
        - dynamic
      title: >-
        V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsQueryParamsItemsMode
    V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsQueryParamsItemsType:
      type: string
      enum:
        - array
        - boolean
        - number
        - object
        - raw
        - string
      title: >-
        V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsQueryParamsItemsType
    V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsQueryParamsItems:
      type: object
      properties:
        key:
          type: string
        mode:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsQueryParamsItemsMode
        value:
          type:
            - string
            - 'null'
        type:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsQueryParamsItemsType
        shape:
          oneOf:
            - $ref: '#/components/schemas/ParamShapeNode'
            - type: 'null'
      required:
        - key
        - mode
      title: >-
        V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsQueryParamsItems
    V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsBodyParamsItemsMode:
      type: string
      enum:
        - static
        - dynamic
      title: >-
        V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsBodyParamsItemsMode
    V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsBodyParamsItemsType:
      type: string
      enum:
        - array
        - boolean
        - number
        - object
        - raw
        - string
      title: >-
        V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsBodyParamsItemsType
    V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsBodyParamsItems:
      type: object
      properties:
        key:
          type: string
        mode:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsBodyParamsItemsMode
        value:
          type:
            - string
            - 'null'
        type:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsBodyParamsItemsType
        shape:
          oneOf:
            - $ref: '#/components/schemas/ParamShapeNode'
            - type: 'null'
      required:
        - key
        - mode
      title: >-
        V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsBodyParamsItems
    V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParams:
      type: object
      properties:
        method:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsMethod
          description: HTTP method to invoke.
        url:
          type: string
          description: >-
            Request URL. Must resolve to a hostname matching the associated
            credential's allowlist.
        headers:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsHeadersItems
          description: Static or dynamic request headers.
        pathParams:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsPathParamsItems
          description: Path parameter placeholders resolved into the URL.
        queryParams:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsQueryParamsItems
          description: Query string parameters.
        body:
          type: string
          description: Raw request body template.
        bodyParams:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParamsBodyParamsItems
          description: Dynamic parameters extracted from `body`.
      required:
        - method
        - url
        - headers
        - pathParams
        - queryParams
        - body
        - bodyParams
      title: V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParams
    V2ApiConnectorsPostResponsesContentApplicationJsonSchemaConfigTimeout:
      type: object
      properties:
        requestSec:
          type: number
          format: double
      required:
        - requestSec
      description: Per-request timeout configuration.
      title: V2ApiConnectorsPostResponsesContentApplicationJsonSchemaConfigTimeout
    V2ApiConnectorsPostResponsesContentApplicationJsonSchemaConfigRetry:
      type: object
      properties:
        maxRetries:
          type: number
          format: double
        retryableStatusCodes:
          type: array
          items:
            type: number
            format: double
      required:
        - maxRetries
        - retryableStatusCodes
      description: >-
        Retry policy. `retryableStatusCodes` are HTTP codes that should trigger
        a retry.
      title: V2ApiConnectorsPostResponsesContentApplicationJsonSchemaConfigRetry
    V2ApiConnectorsPostResponsesContentApplicationJsonSchemaConfigRedirects:
      type: object
      properties:
        maxRedirects:
          type: number
          format: double
      required:
        - maxRedirects
      description: HTTP redirect handling.
      title: V2ApiConnectorsPostResponsesContentApplicationJsonSchemaConfigRedirects
    V2ApiConnectorsPostResponsesContentApplicationJsonSchemaConfigRateLimit:
      type: object
      properties:
        maxRequestsPerWindow:
          type: number
          format: double
      required:
        - maxRequestsPerWindow
      description: Rate limit applied to outbound requests from this connector.
      title: V2ApiConnectorsPostResponsesContentApplicationJsonSchemaConfigRateLimit
    V2ApiConnectorsPostResponsesContentApplicationJsonSchemaConfig:
      type: object
      properties:
        timeout:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostResponsesContentApplicationJsonSchemaConfigTimeout
          description: Per-request timeout configuration.
        retry:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostResponsesContentApplicationJsonSchemaConfigRetry
          description: >-
            Retry policy. `retryableStatusCodes` are HTTP codes that should
            trigger a retry.
        redirects:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostResponsesContentApplicationJsonSchemaConfigRedirects
          description: HTTP redirect handling.
        rateLimit:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostResponsesContentApplicationJsonSchemaConfigRateLimit
          description: Rate limit applied to outbound requests from this connector.
      required:
        - timeout
        - retry
        - redirects
        - rateLimit
      title: V2ApiConnectorsPostResponsesContentApplicationJsonSchemaConfig
    api-connectors_createApiConnector_Response_200:
      type: object
      properties:
        apiConnectorId:
          type: string
          description: Unique identifier of the API connector.
        name:
          type: string
          description: Display name of the connector.
        params:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostResponsesContentApplicationJsonSchemaParams
        config:
          $ref: >-
            #/components/schemas/V2ApiConnectorsPostResponsesContentApplicationJsonSchemaConfig
        createdBy:
          type: string
          description: The identifier of the user who created this object.
        updatedBy:
          type: string
          description: The identifier of the user or process that last updated this object.
        createdAt:
          type: string
          format: date-time
          description: When the object was created.
        updatedAt:
          type: string
          format: date-time
          description: When the object was last updated.
        description:
          type: string
          description: Human-readable description.
        authId:
          type:
            - string
            - 'null'
          description: >-
            Identifier of the API credential (`apiCredentialId`) used to
            authenticate requests. `null` if unauthenticated.
      required:
        - apiConnectorId
        - name
        - params
        - config
        - createdBy
        - updatedBy
        - createdAt
        - updatedAt
      title: api-connectors_createApiConnector_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Request**

```json
{
  "name": "string",
  "params": {
    "method": "GET",
    "url": "string",
    "headers": [
      {
        "key": "string",
        "mode": "static"
      }
    ],
    "pathParams": [
      {
        "key": "string",
        "mode": "static"
      }
    ],
    "queryParams": [
      {
        "key": "string",
        "mode": "static"
      }
    ],
    "body": "string"
  }
}
```

**Response**

```json
{
  "apiConnectorId": "string",
  "name": "string",
  "params": {
    "method": "GET",
    "url": "string",
    "headers": [
      {
        "key": "string",
        "mode": "static",
        "value": "string",
        "type": "array",
        "shape": {}
      }
    ],
    "pathParams": [
      {
        "key": "string",
        "mode": "static",
        "value": "string",
        "type": "array",
        "shape": {}
      }
    ],
    "queryParams": [
      {
        "key": "string",
        "mode": "static",
        "value": "string",
        "type": "array",
        "shape": {}
      }
    ],
    "body": "string",
    "bodyParams": [
      {
        "key": "string",
        "mode": "static",
        "value": "string",
        "type": "array",
        "shape": {}
      }
    ]
  },
  "config": {
    "timeout": {
      "requestSec": 1.1
    },
    "retry": {
      "maxRetries": 1.1,
      "retryableStatusCodes": [
        1.1
      ]
    },
    "redirects": {
      "maxRedirects": 1.1
    },
    "rateLimit": {
      "maxRequestsPerWindow": 1.1
    }
  },
  "createdBy": "string",
  "updatedBy": "string",
  "createdAt": "2024-01-15T09:30:00Z",
  "updatedAt": "2024-01-15T09:30:00Z",
  "description": "string",
  "authId": "string"
}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/api-connectors"

payload = {
    "name": "string",
    "params": {
        "method": "GET",
        "url": "string",
        "headers": [
            {
                "key": "string",
                "mode": "static"
            }
        ],
        "pathParams": [
            {
                "key": "string",
                "mode": "static"
            }
        ],
        "queryParams": [
            {
                "key": "string",
                "mode": "static"
            }
        ],
        "body": "string"
    }
}
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/api-connectors';
const options = {
  method: 'POST',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{"name":"string","params":{"method":"GET","url":"string","headers":[{"key":"string","mode":"static"}],"pathParams":[{"key":"string","mode":"static"}],"queryParams":[{"key":"string","mode":"static"}],"body":"string"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/api-connectors"

	payload := strings.NewReader("{\n  \"name\": \"string\",\n  \"params\": {\n    \"method\": \"GET\",\n    \"url\": \"string\",\n    \"headers\": [\n      {\n        \"key\": \"string\",\n        \"mode\": \"static\"\n      }\n    ],\n    \"pathParams\": [\n      {\n        \"key\": \"string\",\n        \"mode\": \"static\"\n      }\n    ],\n    \"queryParams\": [\n      {\n        \"key\": \"string\",\n        \"mode\": \"static\"\n      }\n    ],\n    \"body\": \"string\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/api-connectors")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"string\",\n  \"params\": {\n    \"method\": \"GET\",\n    \"url\": \"string\",\n    \"headers\": [\n      {\n        \"key\": \"string\",\n        \"mode\": \"static\"\n      }\n    ],\n    \"pathParams\": [\n      {\n        \"key\": \"string\",\n        \"mode\": \"static\"\n      }\n    ],\n    \"queryParams\": [\n      {\n        \"key\": \"string\",\n        \"mode\": \"static\"\n      }\n    ],\n    \"body\": \"string\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sigmacomputing.com/v2/api-connectors")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"string\",\n  \"params\": {\n    \"method\": \"GET\",\n    \"url\": \"string\",\n    \"headers\": [\n      {\n        \"key\": \"string\",\n        \"mode\": \"static\"\n      }\n    ],\n    \"pathParams\": [\n      {\n        \"key\": \"string\",\n        \"mode\": \"static\"\n      }\n    ],\n    \"queryParams\": [\n      {\n        \"key\": \"string\",\n        \"mode\": \"static\"\n      }\n    ],\n    \"body\": \"string\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sigmacomputing.com/v2/api-connectors', [
  'body' => '{
  "name": "string",
  "params": {
    "method": "GET",
    "url": "string",
    "headers": [
      {
        "key": "string",
        "mode": "static"
      }
    ],
    "pathParams": [
      {
        "key": "string",
        "mode": "static"
      }
    ],
    "queryParams": [
      {
        "key": "string",
        "mode": "static"
      }
    ],
    "body": "string"
  }
}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/api-connectors");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"string\",\n  \"params\": {\n    \"method\": \"GET\",\n    \"url\": \"string\",\n    \"headers\": [\n      {\n        \"key\": \"string\",\n        \"mode\": \"static\"\n      }\n    ],\n    \"pathParams\": [\n      {\n        \"key\": \"string\",\n        \"mode\": \"static\"\n      }\n    ],\n    \"queryParams\": [\n      {\n        \"key\": \"string\",\n        \"mode\": \"static\"\n      }\n    ],\n    \"body\": \"string\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "string",
  "params": [
    "method": "GET",
    "url": "string",
    "headers": [
      [
        "key": "string",
        "mode": "static"
      ]
    ],
    "pathParams": [
      [
        "key": "string",
        "mode": "static"
      ]
    ],
    "queryParams": [
      [
        "key": "string",
        "mode": "static"
      ]
    ],
    "body": "string"
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/api-connectors")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```